G-41. Bellman Ford Algorithm

Поділитися
Вставка
  • Опубліковано 2 гру 2024

КОМЕНТАРІ • 361

  • @takeUforward
    @takeUforward  2 роки тому +98

    Let's continue the habit of commenting “understood” if you got the entire video. Please give it a like too, you don't 😞
    Do follow me on Instagram: striver_79

  • @mandarbhatye17
    @mandarbhatye17 2 роки тому +52

    Thanks

  • @harleenkaur7751
    @harleenkaur7751 Рік тому +90

    Thanks Striver. Trust me, even in my paid course, they just simply explained the working of Dijkstra and Bellman without going into such detail. U r the best teacher.

    • @dharmvir2330
      @dharmvir2330 Рік тому +9

      True , i am also here from a paid course , Someone believes it or not These explanations are way better than in a paid course.

    • @harshitrautela6585
      @harshitrautela6585 4 місяці тому

      @@dharmvir2330 So why did you take the paid course? Is there any advantage you can think of that the paid course is giving better than Striver(just curious to know)?

  • @EliasEH89
    @EliasEH89 9 місяців тому +18

    Thank u.
    Note: The Dijkstra's algorithm implemented in G-32 can handle any negative edges graph EXCEPT the following cases:
    1- Directed graph having any negative cycle (cycle with sum < 0)
    2- Undirected graph having any negative edge because the edge in undirected graph is by itself a cycle

    • @Mercer80
      @Mercer80 8 місяців тому +1

      What if graph is disconnected and negative cycle isnt reachable from source then your first point is false.

    • @shravani2922
      @shravani2922 6 місяців тому +1

      Your thought is right, my doubt is why not follow Dijkstras algorithm implemented in G-32 for directed graphs with no negative cycles. The time complexity is even less than Bellmanford algorithm. What is the use of Bellman ford algorithm?

    • @tasneemayham974
      @tasneemayham974 6 місяців тому

      @@Mercer80 I think we can apply a quick visited check? Like we did in the first lectures?

  • @satyakidas7536
    @satyakidas7536 День тому

    After many years I finally understood with your example why bellman ford runs for (n - 1) iterations. Thank you

  • @akshaysoni3496
    @akshaysoni3496 Рік тому +65

    Improve Time Complexity by exponential with just minor observation:
    Put int count =0; After the first loop & increment the value of count by 1 when the dist array will get updated and at the end of the second loop, if the value of count is not increased then directly return dist array. if no update in dist array happened that means we already calculate dist array, no need to do further iteration, In the worst case it does not have any impact, but for rest, it decreases TC a lot. It Reduce the number of iteration in Best & Average cases.

    • @srimanproductions8396
      @srimanproductions8396 Рік тому +1

      this should be pinned

    • @amalkumar256
      @amalkumar256 Рік тому

      I did the same thing.

    • @shivangisehgal
      @shivangisehgal Рік тому

      exactly!

    • @nalingoyal881
      @nalingoyal881 9 місяців тому +1

      Is this case even possible? in a graph like this : a-> b-> c . if we have found smaller distance for a->b , we will surely find shorter distance for b->c in next iteration. Let me know if you think differently.

    • @dank7044
      @dank7044 5 місяців тому +1

      @@nalingoyal881 Bhai you would find smoller distance for c in the same iteration.

  • @av21015
    @av21015 2 роки тому +10

    You explained it really well, If I was to trace this myself I would have sat for an entire day.

  • @mashfy6314
    @mashfy6314 2 роки тому +260

    This guy got superpower. Can be cast as a Marvel hero "The Explainer" .

    • @samarthagarwal6965
      @samarthagarwal6965 2 роки тому +22

      And we all guys as watchers 😂

    • @noobcoder6306
      @noobcoder6306 Рік тому

      nice one

    • @noobcoder6306
      @noobcoder6306 Рік тому +2

      @@samarthagarwal6965 already taken by the "Watcher"

    • @blutoo1363
      @blutoo1363 Рік тому +9

      I think Striver is already a good enough superhero name

    • @amanasrani6405
      @amanasrani6405 5 місяців тому

      Wahi yr his teachings skills with so much of patiencee

  • @tanyacharanpahadi158
    @tanyacharanpahadi158 6 місяців тому +4

    OMG! too much hype about bellman ford algorithm and this is what it is? WOW! you made it so simple. Thanks a ton striver!

  • @GauravThinks
    @GauravThinks Рік тому +12

    Question: why do we need N-1 iterations?
    Reason: Because we first of all set the source distance out ot all the N edges, now we have N-1 edges, to fill their distances w.r.t source, we need at max N-1 iterations for each Node.

  • @imajt5
    @imajt5 10 місяців тому +1

    Have watched multiple videos, but got the understanding from this explaination. Thanks

  • @srinayclg390
    @srinayclg390 Рік тому +28

    when u said "yes u r correct", my confidence became infinity❤

  • @LokeshSharma-hm5jz
    @LokeshSharma-hm5jz Рік тому +1

    understood, I dont know why i was afraid of this algo in explaining. You made it a butter.

  • @arnabdebnath2425
    @arnabdebnath2425 2 роки тому +2

    Bhaiya nind se uth ke breakfast mai apka video khaneka Maza hi kuch Alag h…….
    Thank you so much bhaiya ….❤

  • @jagannathan1014
    @jagannathan1014 Рік тому +2

    Shortly, if N nodes, the node at the farthest level will be at

  • @ashutoshkumargiri3194
    @ashutoshkumargiri3194 Рік тому

    One of the best playlist of Graph on youtube bhaia you deserve more

  • @naitikrathore3317
    @naitikrathore3317 2 роки тому +3

    2 din baad DAA ki paper hai and Bellman Ford aayega exam me, soch hi rha tha ki striver agr next video yhi upload kr de fir to mjaa hi aa jaye and aaj subh dekha BOOM!!

  • @HarshnitePrasad
    @HarshnitePrasad Рік тому +1

    Things i figured out :
    1. If you know a path to reach a node you can figure out the paths to reach nodes adjacent to it.
    2. why repeat n-1 times, every time you run through the edges you find a path to reach the node and the cost to reach it, if its better you update, incase the cost doesnt update you have been able to exhaust the minimum cost path.

  • @tasneemayham974
    @tasneemayham974 6 місяців тому +1

    SUBSCRIBED FROM FIRST RECURSION LIST VIDEO, SIRE!!!! UNDERRRSSTOOODDDD

  • @CodeNow-nc4rk
    @CodeNow-nc4rk 2 місяці тому

    23:34 -
    If someone is wondering like me as to why the edges are passed by reference using &
    If you don't use a reference, the function would create a copy of the edges vector every time the function is called, which can be very costly in terms of memory and time, especially for large graphs

  • @dhanashreegodase4445
    @dhanashreegodase4445 Рік тому +1

    thanks striver, you are the real gem

  • @harshith4549
    @harshith4549 5 місяців тому

    We can also fit the negetive cycle check in the for loop with extending its range to V and checking if its the Vth iteration in relaxtion without writing repeated code. Also the best and worst cases can be improved by keeping a count of how many relaxations done in each iteration which signifies that if at any point no relaxation can be done then no further iteration is required bcoz there will be no change in distances further. Here's how its done:
    vector bellman_ford(int V, vector& edges, int S) {
    vector dist(V, 1e8);
    dist[S] = 0;
    for(int i = 1; i

  • @ashutoshpandey1639
    @ashutoshpandey1639 Рік тому +2

    one thing should also be mentioned that if a graph on N nodes have cycle, then their is path exist having more than N - 1 edges from first to last node.
    By the way best explanation on UA-cam👌

  • @prateekshrivastava2802
    @prateekshrivastava2802 Рік тому

    Best explaination of this algo till date !!

  • @pranshu_awasthi
    @pranshu_awasthi 8 місяців тому +2

    Dijsktra's code which striver has taught works for negative edges , it just not works for Negative edge cycles. So all in all , it would work for DAG with positive / negative weights.

    • @tasneemayham974
      @tasneemayham974 6 місяців тому +1

      Of course, because Dijkstra doesn't work for negative edges in UNdirected grapsh: What if you have 0 - 1 with -1 weight? It will give TLE. But in directed, 0->1 with -1, 1 can never go back to 0 so the loop will not work.

    • @pranshu_awasthi
      @pranshu_awasthi 5 місяців тому +1

      @@tasneemayham974 That's what I said. It works for DAG.

  • @newsbuster2194
    @newsbuster2194 Рік тому +1

    Thanks for putting such kind of effort for us.

  • @ayushsharma-bw5ch
    @ayushsharma-bw5ch Рік тому +1

    we need to relax each edge for n - 1 times but in the code we are running loop for

    • @vishnubanjara5209
      @vishnubanjara5209 Рік тому +6

      if we assume it 0 index based then V-2 is right and if we take it 1 based than simply run it for 1 less as V-1

    • @shreyanshagrawal3115
      @shreyanshagrawal3115 Рік тому +3

      for(int i = 0; i < N; i++) : runs for N times ( 0 to N-1)
      for(int i = 0; i < N-1; i++) : runs for N-1 times ( 0 to N-2) - which is required

  • @keshavprasad1017
    @keshavprasad1017 6 місяців тому

    thank you so much for the clean and crisp explanation.

  • @decepticonWave
    @decepticonWave Рік тому +3

    The fact that you explained N-1 is why you are the GOAT. Please make a paid course and we will pay

    • @ashutoshpandey1639
      @ashutoshpandey1639 Рік тому

      But the one thing should also be mentioned that if a graph on N nodes have cycle then their is path exist having edges more than N - 1.

  • @Curiousdev01
    @Curiousdev01 Рік тому +4

    Amazing content sir !! ..... if I get a job will be because of you.🙂

  • @coder6109
    @coder6109 7 місяців тому

    Imp when to apply - > when have -ve cycles, idea-> relax all the edges v-1 times , tc->(O(VE))

  • @ajitpal0821
    @ajitpal0821 Рік тому +1

    5 nodes not edges at 17:24 @take U forward

  • @Kokowangmini
    @Kokowangmini Рік тому +1

    understood, It was so Awesome.

  • @Chirayu19
    @Chirayu19 Рік тому

    You got so much energy, bro!

  • @AyushiPanday12
    @AyushiPanday12 Рік тому

    Thanks Striver for these wonderful lectures. Understood.

  • @alessandrocamilleri1239
    @alessandrocamilleri1239 Рік тому +1

    Top notch explanation as usual. I would have included an update flag to pre-empt unnecessary iterations.

  • @rajeshj4066
    @rajeshj4066 Рік тому +1

    @ 16:00 : explained why it has n-1 iterations

  • @amankush2408
    @amankush2408 5 місяців тому

    Understood. Great explanation for the intuition.

  • @mdyousufgazi4030
    @mdyousufgazi4030 Рік тому

    the thought process is insane

  • @cinime
    @cinime 2 роки тому +1

    Understood! Super amazing explanation as always, thank you very much!!

  • @user-zn3be9ik1x
    @user-zn3be9ik1x Рік тому

    start the relaxation loop from i=1 to i

  • @CodeMode9313
    @CodeMode9313 Рік тому

    Habibi ye ek number bideo bana di tumne toh ...baut baut danyawaad

  • @stith_pragya
    @stith_pragya 11 місяців тому +2

    Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @120-venkataraghavareddyvar4
    @120-venkataraghavareddyvar4 Рік тому +1

    I guess for the question why we need to do n-1 relaxations to each node is that ,, suppose we have 3 nodes directly connected a node and we have relaxed those nodes,, now in typical dijkstra algo,, the node with smallest value of relaxation will never get relaxed again, but if there are negative weights,, then there is a chance that the the node with smallest value of relaxation will get relaxed again. Since each node at max gets connected to n-1 nodes, so thus n-1 relaxations.

  • @rithikraj4316
    @rithikraj4316 4 місяці тому

    Simple in every cycle worst can be 1 updation, so we need to update n - 1 updation as we already have 0 or src updated manually

  • @Stickman-rz9nu
    @Stickman-rz9nu 6 місяців тому

    bhaiya , in the for loop terminating condition should be “ i < V “ for n-1 iterations

  • @divyareddy7622
    @divyareddy7622 Місяць тому +1

    takeaway: having n-1 iterations, helps bellman ford to avoid infinite loop. It won't again try to find a better distance.

  • @virgarg9653
    @virgarg9653 Рік тому

    Beautiful Explanation . Loved your content keep going 100%

  • @Kparkhade
    @Kparkhade 4 місяці тому

    Maja aa gaya
    Itna khatarnak explanation bro 🎉

  • @priyapandey8951
    @priyapandey8951 Місяць тому

    I just wanted to play around with dijkstra and I know this in not an optimal solution and thought of doing the negative cycle part with dijsktra only. My thought process is very simple with djkstra also you could solve the problem the only issue was negative cycle. Now a cycle in itself is not an issue but a cycle with reducing distance does. According to the condition of dijkstra it would enter the if block if we get a decreasing distance and this will only happen in negative cycle or in linear path. To check that we can store paths for each node. Next time we visit that node we check do we already have the node itself in the path that means we are in a cycle or else there is a different path that led us to the node.
    Code:
    vector bellman_ford(int V, vector& edges, int S) {
    // Code here
    vector adj(V);
    for(int i=0;i

  • @UtpalPodder-IITian
    @UtpalPodder-IITian 5 місяців тому

    Presense of negative edge does not always result incorrect result ...that could be easily proved in the second example if there is a path say from 4 to 3 with -1 edge weight ....but if the negative edge cycle change the previous path length which we got after n-1 iteration then it cause problem.

  • @dipendrapratap6495
    @dipendrapratap6495 2 місяці тому

    If we will take nodes in a increasing order then that time I think we can find the distance in 2-3 iteration as well we don't need to do n-1 iterations

  • @komalkrishna7836
    @komalkrishna7836 2 роки тому

    Wow! very well explained, completely Understood

  • @kaichang8186
    @kaichang8186 2 місяці тому

    understood, thanks for the intuition part

  • @kiranpoojary493
    @kiranpoojary493 Місяць тому

    20:11 activated SUPER SONIC MODE 🔥

  • @sdfg204
    @sdfg204 8 місяців тому

    Had no idea it was this easy, damn. Obviously now that i know the logic, i don't even need to remember it.

  • @g51661
    @g51661 Рік тому

    Thank you, Striver!
    Understood

  • @vakhariyajay2224
    @vakhariyajay2224 Рік тому +1

    Thank you very much. You are a genius.

  • @Alwaysalearner123
    @Alwaysalearner123 Рік тому

    In for loop i

  • @lokeshroy3944
    @lokeshroy3944 Рік тому

    intution was just 🔥🔥🔥🔥🔥🔥🔥🔥

  • @rajatjakhar3146
    @rajatjakhar3146 Рік тому +1

    great explanation 🔥🔥🔥🔥

  • @udaytewary3809
    @udaytewary3809 Рік тому

    Understood bhaiya 🙏❤️

  • @ankitpandey7262
    @ankitpandey7262 2 роки тому

    Understood !! Amazing as always

  • @suyashjain3223
    @suyashjain3223 10 місяців тому

    Amazing Explanation!!🔥🔥

  • @varunakrishnani7688
    @varunakrishnani7688 Рік тому +1

    Understood!! :)
    Thank you! 🙏🏻😊

  • @sambhavgandhi6553
    @sambhavgandhi6553 Рік тому

  • @dipanshumahto9520
    @dipanshumahto9520 Рік тому

    baad m distance array ka sum nikal k check kr skte h n negative cycle ka
    for(int i=0;i

  • @psurya3053
    @psurya3053 2 роки тому +1

    thank you bhaiyya , please can you make a playlist on examples on segment trees from codeforces

  • @stark2461
    @stark2461 Рік тому

    In Case of Negative weight cycles, Dijkstra don't run forever. It produces wrong answer

  • @YourITGuy9
    @YourITGuy9 2 роки тому +2

    at 17.25 Edges are 5 i think u r referring to the no of nodes not edges

  • @kasamadhu3509
    @kasamadhu3509 Рік тому +2

    striver: Directed Acyclic Graph with negative edges we can use Dijkstra's right?
    Example: vertices 3, edge 3
    node node weight;
    0 1 10
    1 2 -8
    0 2 5
    source 0 ;
    it is giving 0, 10, 2 correct, bellman ford is used for only detecting negative cycles that can't be done using dijkstra's as you explained in series.

    • @akashkumarsingh8369
      @akashkumarsingh8369 Рік тому +1

      same confusion hai bhai. smjh nhi aa rha agar cycle nhi hua aur negative weight hai to dijkstra glt ans dega ya shi. Dry run krne pr shi hi aa rha hai.

    • @lakshsinghania
      @lakshsinghania Рік тому

      @@akashkumarsingh8369 it shouldn't work as per the real meaning of dijkstra's whether its
      1. having neg weights
      2. having neg cycle becoz this already includes negative weight in the path

    • @lakshsinghania
      @lakshsinghania Рік тому

      @@akashkumarsingh8369 koi aur tc lo and then check

    • @dhruvgupta3879
      @dhruvgupta3879 Рік тому

      it won't work with dijkstra. We mark a node as visited in dijkstra and do not visit it again, which should not be done in case of negative weights.

    • @jiyabhagat6510
      @jiyabhagat6510 10 місяців тому +1

      Yes, Dijkstra can be used for Directed Acyclic Graph with negative weights. Since it doesn't have a negative cycle, it will not get caught in an infinite loop

  • @kushalkollu8628
    @kushalkollu8628 3 місяці тому

    striver bhai is goated

  • @doingsneakypeakylike
    @doingsneakypeakylike 2 роки тому

    Solid explanation man! Thanks!

  • @herculean6748
    @herculean6748 Рік тому

    lots of love and respect🙌

  • @soninirav
    @soninirav 2 роки тому

    Amazing , very well explained 🔥🔥

  • @saniyaverma914
    @saniyaverma914 7 місяців тому

    Understood, thank you bhaiya

  • @smile8510
    @smile8510 2 роки тому +2

    Master piece !

  • @aryashjain7893
    @aryashjain7893 2 роки тому

    watching it at 4 a.m. and when u say , I got a better guy, it really hurts :)🤣🤣

  • @juniorboy1903
    @juniorboy1903 2 роки тому +1

    Understood😉 bhaiya

  • @vyomyadav6497
    @vyomyadav6497 Рік тому

    Good, well explained.

  • @Gamer-nz3cx
    @Gamer-nz3cx 5 місяців тому +1

    26:08 its cubic not quadratic

  • @kr_ankit123
    @kr_ankit123 2 роки тому +1

    Understood👍👍
    Thanks a lot

  • @VrundLeuva-g5s
    @VrundLeuva-g5s 5 місяців тому

    very nice explanation

  • @UECAshutoshKumar
    @UECAshutoshKumar 11 місяців тому +1

    Thank you sir 🙏

  • @MojnoSardar
    @MojnoSardar Рік тому

    Very well explained.

  • @vaalarivan_p
    @vaalarivan_p Рік тому +1

    5:28 - 22:00

  • @chitranshkulshrestha485
    @chitranshkulshrestha485 4 місяці тому

    Thanks for the intution

  • @auroshisray9140
    @auroshisray9140 Рік тому

    Well explained bhai!

  • @sunnyyt4082
    @sunnyyt4082 7 місяців тому

    can we consider the no of iterations as maximum path length from source?

  • @Mandh-c7r
    @Mandh-c7r 4 місяці тому

    what if we sort the given input such that the src node is at the start and so on......will we be able to to compute it all in just 1 relaxation then?

  • @NAYANPATELTECH
    @NAYANPATELTECH 11 місяців тому

    Super explanation😀

  • @KurumiddeKezia
    @KurumiddeKezia 21 день тому

    tq striver bhaiyya

  • @tasneemayham974
    @tasneemayham974 6 місяців тому

    I have a question: the only reason we do N-1 iterations is because the node might be ordered from end to beginning with the source at the end and its connected node after. What if we re-write the graph such that the first edge is always the source and so on.. till the end? Will that need N-1 iterations now?

  • @anonymous-zi5tt
    @anonymous-zi5tt 6 місяців тому

    I had this small question, we dont have exact infinity in implemntation so, suppose we have 1e9, then at some condition of negative edge weight 1e9-2 > 1e9 would we true?

  • @harshalgarg1676
    @harshalgarg1676 3 місяці тому

    Amazing, thanks a lot.

  • @ritikpandey5939
    @ritikpandey5939 7 місяців тому +1

    He is Godfather ❤❤❤❤❤❤❤❤❤❤❤❤❤❤🎉🎉🎉🎉🎉🎉❤❤❤❤❤

  • @krishnashah6654
    @krishnashah6654 Рік тому

    nicely explained, thanks alot

  • @kirankuyate6056
    @kirankuyate6056 Рік тому

    greate explaination and with great energy while explaining that make people more creative affracting getting more..💖

  • @bhargavreddy5938
    @bhargavreddy5938 Рік тому

    Well explained man ❤️

  • @gangsta_coder_12
    @gangsta_coder_12 Рік тому +1

    Understood 🔥🔥